#include <stdio.h>
#include <ctype.h>
#include <math.h>
#include <sys/types.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <fcntl.h>

/* Miscellaneous Constants */
#define true		1
#define false		0
#define FALSE		0
#define TRUE		1

#define BIGVECLEN	5000000	
#define GOLHASHTABLESIZE 102397

/* Structure to hold bitvector */
typedef struct bitvecrec
{
    char	*vector;	/* Sequence of bytes to hold bitvector */
    int		size;		/* Of vector, in bytes */
    int		pos;		/* Current byte number */
    int		bit;		/* Current bit in byte */
    int		cur;		/* Temporary space for putting, getting bits */ 
    int		len;		/* Number of bits used */
    int		last;		/* Total of runlengths seen so far */
		/* The last field is an oddity; it allows us to have
		   several bitvectors open at once */
} BITVEC;

typedef struct golombhashstruct
{
	int			b;	/* b value used for lookup */
	int			q;  /* q value that is floor(log_2(b)) */
} GOLHASH;

#define L2(f)		( log10((f)) / 0.301029995 /*=log10(2.0)*/ )
#define L4(f)		( log10((f)) / 0.602059999 /*=log10(4.0)*/ )
#define L6(f)		( log10((f)) / 0.778151250 /*=log10(6.0)*/ )
#define L8(f)		( log10((f)) / 0.903089990 /*=log10(8.0)*/ )
#define LN(f)		( log10((f)) / 0.434294480 /*=log10(e)*/ )

char *malloc(int);
void	padvec(BITVEC *), expandvec(BITVEC *), initcmp(), initvec(BITVEC *, int),
		freevec(BITVEC *), resetvec(BITVEC *), inittree(), cleanuptree(),
		dumpvec(BITVEC *,FILE *), dumptree(char *);
	
int vbyteread(FILE *);
int vbytewrite(int, FILE *);
